# JAID experiment scripts #

For someone not familiar with JAID and/or the Defects4J benchmark, it could take quite some time to set up and run the experiments; scripts in this directory will get you started with this. 

### Prerequisites ###

* Java SDK 8
* Python3 (with `pip3`)  

The directory containing the scripts is denoted `<PATH_TO_SCRIPTS>` in the rest of this document.

### Preparation ###

1. Run ```main.py``` to show the help message:

   ```$ python3 <PATH_TO_SCRIPTS>/src/main.py -h```

2. To list all Defects4J bugs that the script can help prepare, run command:

   ```$ python3 <PATH_TO_SCRIPTS>/src/main.py --info```

   When running the command, you will be prompted to set the environment variable `JAVA_HOME` in your system to point to a Java SDK of version 8, if that is not the case yet. 
   
### Launch JAID on one bug ###

* To setup JAID to run on Defects4J bug `Lang33`:

   ```$ python3 <PATH_TO_SCRIPTS>/src/main.py --pre Lang33```

   The script will download the buggy project for `Lang33` into `<PATH_TO_SCRIPTS>/buggy_repo/commmons-lang33`, and generate the properties file at `<PATH_TO_SCRIPTS>/buggy_repo/commmons-lang33/local_fixja.properties`. 

* Once the inputs for fixing `Lang33` are ready, launch JAID and start fixing:

   ```$ java -ea -cp <JAID_CLASSPATH> hk.polyu.comp.fixja.fixer.Application --FixjaSettingFile <PATH_TO_SCRIPTS>/buggy_repo/commmons-lang33/local_fixja.properties```

* To set up and launch JAID in a single step:

  ```$ python3 <PATH_TO_SCRIPTS>/src/main.py --run Lang33```

### Print out the result summary ###

* To print out the result summary of a fixing session:

   ```$ python3 <PATH_TO_SCRIPTS>/src/main.py --read Lang33```

