import os

JUNIT_PATH = ['libs', 'junit-4.12.jar']
HAMCREST_PATH = ['libs',  'hamcrest-core-1.3.jar']
WORKING_REL_PATH = 'buggy_repo'
D4J_FOLDER = 'defects4j'
LIB_FOLDER = 'libs'
JAID_JAR = 'fixja-all.jar'


class MyConfig(object):
    """A configInfo object"""
    p_JDKDir = 'JDKDir'

    def __init__(self):
        super(MyConfig, self).__init__()
        self.JDKDir = ''
        self.root = get_script_root_path()

    def __str__(self):
        return "JDKDir: %s\n" \
               % (self.JDKDir,
                  )

    def get_working_path(self):
        working_path = os.path.join(self.root, WORKING_REL_PATH)
        if not os.path.exists(working_path):
            os.mkdir(working_path)
        return working_path

    def get_d4j_path(self):
        return os.path.join(self.root, LIB_FOLDER, D4J_FOLDER)

    def get_lib_path(self):
        return os.path.join(self.root, LIB_FOLDER)

    def get_junit_path(self):
        path = self.root
        for item in JUNIT_PATH:
            path = os.path.join(path, item)
        return path

    def get_hamcrest_path(self):
        path = self.root
        for item in HAMCREST_PATH:
            path = os.path.join(path, item)
        return path

    def get_jaid_path(self):
        return os.path.join(self.root, LIB_FOLDER, JAID_JAR)

    # def get_jdk_path(self):
    #     if not self.JDKDir:
    #         self.JDKDir = get_java8_home()
    #     return self.JDKDir


def get_script_root_path():  # get current file name and working path
    py_path = os.path.realpath(__file__)
    script_path, script_name = os.path.split(py_path)
    root_path, src_folder = os.path.split(script_path)
    if src_folder == 'src':
        return root_path
    else:
        raise EnvironmentError('Cannot get root working path.')
