PROPERTIES_FILE_NAME = 'setting.properties'
REQUIREMENT_FILE_NAME = 'requirements.txt'
ANALYSIS_TMP = 'analysis_tmp.txt'
ZIP_SUFFIX = '.zip'
FIXJA_ARG_PROPERTY = '--FixjaSettingFile'
ARGS_FORMAT = '<BUG_ID1,BUG_ID2,...>'
D4J_BUGID_FORMAT = '<REPO_NAME><DEFECTS4J_VERSION_ID>'

repositories = {'closure': 'closure-compiler',
                'lang': 'commons-lang',
                'math': 'commons-math',
                'time': 'joda-time',
                'chart': 'JFreechart',
                'mockito': 'mockito'}

valid_bvs = {
    'closure': ['1', '10', '104', '113', '118', '125', '126', '18', '31', '33', '40', '5', '62', '63', '70', '73',
                '86', '10', '125', '126', '14', '33', '40', '51', '62', '63', '70', '73'],
    'lang': ['24', '33', '38', '39', '45', '51', '55', '61', '10', '24', '33', '35', '38', '39', '43', '44', '45', '46',
             '51', '53', '55', '57', '58', '59', '6', '7'],
    'math': ['101', '105', '32', '5', '50', '53', '70', '80', '82', '85', '105', '2', '25', '28', '3', '32', '33', '34',
             '35', '40', '42', '49', '5', '50', '53', '57', '58', '69', '70', '73', '78', '8', '80', '81', '82', '84',
             '85', '87', '88', '89', '90', '93', '95', '97', '99'],
    'time': ['19', '15', '4'],
    'chart': ['1', '13', '14', '15', '19', '21', '24', '25', '26', '3', '5', '7', '8', '9'],
    'mockito': ['38', '24', '1', '7', '29', '28', '33', '22', '11', '12', '18', '3', '21', '5', '34', '6', '4', '37',
                '8', '13', '27', '20', '35'],}

COMMAND_SHOW_INFO = '--info'
COMMAND_SHOW_INFO_DESC = 'Display available projects and bug ids.'

COMMAND_SHOW_CONFIG = '--exp_config'
COMMAND_SHOW_CONFIG_DESC = 'Display the configuration file dir for experiment and its contents.'

COMMAND_PREPARE = '--pre'
COMMAND_PREPARE_DESC = 'Prepare specific buggy version (property file)'

COMMAND_RUN = '--run'
COMMAND_RUN_DESC = 'Execute JAID against specific buggy program(s)'

COMMAND_READ = '--read'
COMMAND_READ_DESC = 'Read JAID output of specific buggy program(s)'


Commands = {
    COMMAND_SHOW_INFO: COMMAND_SHOW_INFO_DESC,
    COMMAND_SHOW_CONFIG: COMMAND_SHOW_CONFIG_DESC,

    COMMAND_PREPARE: COMMAND_PREPARE_DESC,
    COMMAND_RUN: COMMAND_RUN_DESC,
    COMMAND_READ: COMMAND_READ_DESC,
}

D4J_OLD_CANDIDATES = {
    'commons-math82': '0B3Jlt8l7iCKAakREc3lHbmtUSVE',
    'commons-math105': '0B3Jlt8l7iCKAbFFua3d6amZSdlE',
    'commons-math5': '0B3Jlt8l7iCKAbUw4emZHSERiZXc',
    'joda-time19': '0B3Jlt8l7iCKAX3A3MWRvallNamc',
    'closure-compiler63': '0B3Jlt8l7iCKAU1ktZTlRYlNFN2c',
    'commons-lang38': '0B3Jlt8l7iCKAVjJNSXpwSUdzek0',
    'closure-compiler5': '0B3Jlt8l7iCKAaGlHQnJIbk52S0E',
    'commons-math101': '0B3Jlt8l7iCKAdUx4TmFfUGRYTzg',
    'closure-compiler118': '0B3Jlt8l7iCKAbWp0MkFGcEZfYm8',
    'closure-compiler86': '0B3Jlt8l7iCKAQTRrUU5KTVktR1U',
    'commons-math80': '0B3Jlt8l7iCKASUZIX3FweGZPX2c',
    'JFreechart24': '0B3Jlt8l7iCKAalA0cHRxRmM3dE0',
    'commons-math85': '0B3Jlt8l7iCKAZHZlV1oxMHRhVG8',
    'JFreechart9': '0B3Jlt8l7iCKAUEhtWUlmaDh0Rlk',
    'closure-compiler125': '0B3Jlt8l7iCKAOVdoUVNQemRFVGM',
    'commons-lang45': '0B3Jlt8l7iCKAU093N0Q3MVg2bm8',
    'commons-lang24': '0B3Jlt8l7iCKAb3RUS09OODdLbVE',
    'closure-compiler1': '0B3Jlt8l7iCKASE9jN1dseERZdVU',
    'closure-compiler113': '0B3Jlt8l7iCKAZHpFbEhyMG8tcDA',
    'closure-compiler33': '0B3Jlt8l7iCKASkQ2OFZKdjRQQTA',
    'closure-compiler70': '0B3Jlt8l7iCKAaUtTNkFidUpsbjg',
    'commons-math50': '0B3Jlt8l7iCKANlgzUXVrWUpJdmc',
    'JFreechart1': '0B3Jlt8l7iCKASFZpUW5BWndnRGM',
    'closure-compiler104': '0B3Jlt8l7iCKAdm5mRVNMbEV6UFE',
    'closure-compiler10': '0B3Jlt8l7iCKAUV9UN3NUWm9jVFE',
    'commons-math53': '0B3Jlt8l7iCKATkJBa2Z1bjdYdmM',
    'commons-math32': '0B3Jlt8l7iCKAWVpmWnpraDQwclk',
    'closure-compiler73': '0B3Jlt8l7iCKAYnNPSzE2dVNERDQ',
    'closure-compiler62': '0B3Jlt8l7iCKAaHM0dHBWODhKM0k',
    'JFreechart26': '0B3Jlt8l7iCKAaFJqSjhrUkRaMkU',
    'commons-lang55': '0B3Jlt8l7iCKAejM5b05FUUJLNmM',
    'closure-compiler126': '0B3Jlt8l7iCKAaFVoS2lyUTc3Ujg',
    'commons-lang61': '0B3Jlt8l7iCKAMHlUV2JYYVdZYXM',
    'commons-lang33': '0B3Jlt8l7iCKAZzJfRHQ1bVk0Wlk',
    'commons-math70': '0B3Jlt8l7iCKARnQ0alNFQVMwSk0',
    'closure-compiler40': '0B3Jlt8l7iCKAcDdBNVpsSW1vaEU',
    'closure-compiler31': '0B3Jlt8l7iCKATGttamxjRjJRb1E',
    'closure-compiler18': '0B3Jlt8l7iCKAcFEzT0hsZEtNUGM',
    'commons-lang51': '0B3Jlt8l7iCKAaHZEVzI4Yk5Yb00',
    'commons-lang39': '0B3Jlt8l7iCKASlNNVzBtUzk4Q1k',
}

D4J_CANDIDATES = {
    'commons-math25': '0B3Jlt8l7iCKAbm02X2xGMWdNQjA',
    'commons-math82': '0B3Jlt8l7iCKAUUxBdFBRSGNUeHM',
    'commons-math99': '0B3Jlt8l7iCKAM3lhQTlQbVZfM0E',
    'commons-math42': '0B3Jlt8l7iCKAc1lycGktTzNHMWs',
    'commons-lang7': '0B3Jlt8l7iCKAQjEtbGo5VzJRSlE',
    'joda-time4': '0B3Jlt8l7iCKATVRreThNbkFoYWM',
    'commons-math33': '0B3Jlt8l7iCKAUnZBajRiU3F6aTA',
    'commons-math105': '0B3Jlt8l7iCKAejAwY1dtV1pXLVU',
    'commons-lang10': '0B3Jlt8l7iCKAc3gzZjhzSEdKdHc',
    'commons-lang53': '0B3Jlt8l7iCKALXJ6OUlWVzNOdlE',
    'commons-math5': '0B3Jlt8l7iCKAUVhDWTVHeDJzd28',
    'commons-math8': '0B3Jlt8l7iCKAT0x2c010WkFBNms',
    'commons-lang46': '0B3Jlt8l7iCKAV1pxTGktODZ3LUk',
    'joda-time19': '0B3Jlt8l7iCKAR3hHMjd4cnMwYXc',
    'closure-compiler63': '0B3Jlt8l7iCKALWFBNy1qYVV3V2c',
    'commons-math2': '0B3Jlt8l7iCKANnVrbTlOQU5CMFE',
    'commons-lang38': '0B3Jlt8l7iCKARmh3SnVzTFRXcXc',
    'JFreechart7': '0B3Jlt8l7iCKAdmJWWkFWTWxxUVk',
    'commons-lang6': '0B3Jlt8l7iCKAX3g0MFFhU21fZGc',
    'commons-math40': '0B3Jlt8l7iCKAS0FwaUZTcTZqalU',
    'commons-math3': '0B3Jlt8l7iCKAWUlmUkIzZW51NDQ',
    'JFreechart13': '0B3Jlt8l7iCKAS1VieUNKUW9idXM',
    'commons-math49': '0B3Jlt8l7iCKAYTVuNUlqVHB2OUE',
    'commons-math80': '0B3Jlt8l7iCKAS3BSQnk1VUtIVzQ',
    'JFreechart15': '0B3Jlt8l7iCKANkNVNjA0YW1IUXM',
    'commons-math34': '0B3Jlt8l7iCKARGppdTYxU0wyejQ',
    'commons-math89': '0B3Jlt8l7iCKAd21OMnFBTjJKSG8',
    'JFreechart24': '0B3Jlt8l7iCKAMVk3MmZRZ19DMGM',
    'commons-math87': '0B3Jlt8l7iCKAc1JCNzhBR3FLVjg',
    'commons-math85': '0B3Jlt8l7iCKASEUtUDN4ZWMwYTA',
    'JFreechart9': '0B3Jlt8l7iCKAcVB5WGloRmg3MzQ',
    'closure-compiler125': '0B3Jlt8l7iCKAdXg3ZGUtanJnamM',
    'commons-lang45': '0B3Jlt8l7iCKASE1WQUM2RGJ4NnM',
    'commons-lang24': '0B3Jlt8l7iCKAZVBiZGF0MUtMdUk',
    'commons-math69': '0B3Jlt8l7iCKAOEIwdHhublp5VEE',
    'commons-math84': '0B3Jlt8l7iCKAU1FKWEJoMmEyX2s',
    'commons-lang57': '0B3Jlt8l7iCKAVlJkbTZwUTFDaU0',
    'JFreechart21': '0B3Jlt8l7iCKAMlhzblFqQUQxMTg',
    'commons-math57': '0B3Jlt8l7iCKANDkzdkJVVlRfSFE',
    'commons-lang43': '0B3Jlt8l7iCKATDFGNVpsdWdFcnc',
    'closure-compiler33': '0B3Jlt8l7iCKASkZoaDJISkZfZUE',
    'closure-compiler70': '0B3Jlt8l7iCKAMmJEcmtHTDQyV0k',
    'commons-lang59': '0B3Jlt8l7iCKANVR6dVUyYmRJYzA',
    'commons-math93': '0B3Jlt8l7iCKAY09aQ2Y2bUttODA',
    'commons-math50': '0B3Jlt8l7iCKAbWNzc0V3eFhiUjg',
    'commons-math28': '0B3Jlt8l7iCKATjBUd0t3Zjl2S0U',
    'JFreechart1': '0B3Jlt8l7iCKAM3UtMnJsOWZ4TUU',
    'closure-compiler10': '0B3Jlt8l7iCKAajNoSG1KVmYzVW8',
    'joda-time15': '0B3Jlt8l7iCKAYWhmWmZqT20zNnM',
    'commons-math95': '0B3Jlt8l7iCKAaGpFbmYtOFIyS00',
    'commons-math53': '0B3Jlt8l7iCKAUW1ybmNKQkJydWs',
    'commons-math32': '0B3Jlt8l7iCKAbXUzWGQ1RDZLQjA',
    'closure-compiler73': '0B3Jlt8l7iCKANHN2TVhvQmx3S0U',
    'commons-math58': '0B3Jlt8l7iCKATy1yMXVid21SVWc',
    'JFreechart5': '0B3Jlt8l7iCKAWk1GMnpwc3BFSjA',
    'closure-compiler62': '0B3Jlt8l7iCKATXFIQ2trNTBhZDQ',
    'JFreechart26': '0B3Jlt8l7iCKAbmdwTW1Ya0pGRmM',
    'commons-lang55': '0B3Jlt8l7iCKAZE95bjM3T0NLdk0',
    'closure-compiler14': '0B3Jlt8l7iCKAdHFkNWVzTVBVV28',
    'closure-compiler126': '0B3Jlt8l7iCKAMUZhcm83bjcwWEk',
    'commons-math81': '0B3Jlt8l7iCKASjhiWDNBRG0yZ00',
    'closure-compiler51': '0B3Jlt8l7iCKAenpLeGJBUG5DM1U',
    'commons-math90': '0B3Jlt8l7iCKAcDhmemswSTBMWUE',
    'commons-math88': '0B3Jlt8l7iCKAZHdfTERvYzhJUzA',
    'commons-math78': '0B3Jlt8l7iCKAVDJUNExUUmpyd00',
    'commons-lang58': '0B3Jlt8l7iCKAZ3hRenVDbm1BMTg',
    'commons-math35': '0B3Jlt8l7iCKAU19jc3FyN1N3NVU',
    'commons-lang33': '0B3Jlt8l7iCKAbWZZcWwyQkNBNTA',
    'commons-math73': '0B3Jlt8l7iCKASmoxVnNZWnNLeFk',
    'commons-math70': '0B3Jlt8l7iCKAQl93Q2h1VTV2NHc',
    'JFreechart3': '0B3Jlt8l7iCKAV182OFVPcmJnNnc',
    'closure-compiler40': '0B3Jlt8l7iCKAYW5MQXRhUGVFcms',
    'commons-math97': '0B3Jlt8l7iCKASmh5cEtkQUxLSDQ',
    'JFreechart25': '0B3Jlt8l7iCKAUHNFTFFaYjlOS3M',
    'JFreechart8': '0B3Jlt8l7iCKAeHNodGRnNC00dDA',
    'JFreechart14': '0B3Jlt8l7iCKAREpUdEcxdTI5dFE',
    'commons-lang35': '0B3Jlt8l7iCKAM0VvdXhuc0E4Y3c',
    'JFreechart19': '0B3Jlt8l7iCKAWjdhNW5rbEpYMzg',
    'commons-lang44': '0B3Jlt8l7iCKARW8tUzZlVjBFamM',
    'commons-lang51': '0B3Jlt8l7iCKAZnRWNGUzUUdtYVU',
    'commons-lang39': '0B3Jlt8l7iCKAM0NLU3FxS2FhQmc',
    'mockito38': '0B3Jlt8l7iCKALTk3VUNxb2Z5TzQ',
    'mockito24': '0B3Jlt8l7iCKAZFBWaW1DeUg5T1E',
    'mockito1': '0B3Jlt8l7iCKAR0QtSlZ2UDFUZHc',
    'mockito7': '0B3Jlt8l7iCKAR0dZY2dDSjdUMjQ',
    'mockito29': '0B3Jlt8l7iCKAd0lhT0VpOUpqMUE',
    'mockito28': '0B3Jlt8l7iCKAX0lXa0E5V2dDdGs',
    'mockito33': '0B3Jlt8l7iCKANklEOTczM2t3bGc',
    'mockito22': '0B3Jlt8l7iCKAaE5RQ1FFSlVlT0E',
    'mockito11': '0B3Jlt8l7iCKAaXRlLUNkRER5Qlk',
    'mockito12': '0B3Jlt8l7iCKAQkt3ZUNwZUtaNjA',
    'mockito18': '0B3Jlt8l7iCKAcUpKdTZPU2lLWFk',
    'mockito3': '0B3Jlt8l7iCKAeGpOQWxoRG12VFU',
    'mockito21': '0B3Jlt8l7iCKAUzhNYV9NVlNFNXM',
    'mockito5': '0B3Jlt8l7iCKAV25Za2xPUHN6elU',
    'mockito34': '0B3Jlt8l7iCKAMjVRX21ESDhPQU0',
    'mockito6': '0B3Jlt8l7iCKAdEwwYzFUeURUVEk',
    'mockito4': '0B3Jlt8l7iCKAQ0NVVi1WQUNFVEk',
    'mockito37': '0B3Jlt8l7iCKARldNaVc3a1NUcm8',
    'mockito8': '0B3Jlt8l7iCKAbklkb3duOEg1ZTQ',
    'mockito13': '0B3Jlt8l7iCKAQWhpUVM2MGtSMFE',
    'mockito27': '0B3Jlt8l7iCKAWVY5UXh0cnc4M3M',
    'mockito20': '0B3Jlt8l7iCKAZG5MMDNwOGctRW8',
    'mockito35': '0B3Jlt8l7iCKARFRzMjlfZExzVGM',
}

